<?php



// Author: CYD
// Class requires mimetypes.lib.txt in the same folder
// mimetypes.lib.txt format is MIME_TYPE | EXSTANSION


class MimeTypes{

	var $mimetypes = Array();
	var $lib_path = '';
	var $lib_filename = 'mimetypes.lib.txt';

	//Constructor
	function MimeTypes($lib_path = ''){

		if($lib_path!=''){
			$this->setMimeLibraryPath($lib_path);
		}

		if($this->isLibraryExists()){

			if(!$this->loadMimetypesData()){

				echo "<b>MimeTypes Class error:</b> MIME types library is empty - <b>".$this->lib_path."/".$this->lib_filename."</b><br/>";
				return false;
			}

		} else {

				echo "<b>MimeTypes Class error:</b> not found MIME types library in <b>".$this->lib_path."/".$this->lib_filename."</b><br/>";
				return false;

		}

	}



	function loadMimetypesData(){


		$handle = fopen($this->lib_path."/".$this->lib_filename, "r");
		while (!feof($handle)) {

		    $buffer = fgets($handle, 4096);

			$element_arr = explode('|', $buffer);
			$memetype = trim($element_arr[0]);

			$memetype_extension = trim($element_arr[1]);

            if($memetype_extension){
				$this->mimetypes[$memetype][] = $memetype_extension;
           	}

		}

		fclose($handle);


		if(!empty($this->mimetypes)){
			return true;
		} else {
			return false;
		}



	}


	function isLibraryExists(){

		if(file_exists($this->lib_path."/".$this->lib_filename)){
			return true;
		} else {
  			return false;
		}

	}


	function setMimeLibraryPath($path){

         $this->lib_path = $path;

	}


	//Returns an Array of exstansions of the mime type
	function getExtensions($mime_string){

		$mime_string = trim($mime_string);

		if(!empty($this->mimetypes[$mime_string])){

			return $this->mimetypes[$mime_string];

		} else {
			return false;
		}

	}


		//Returns an Array of exstansions of the mime type
		// if us $return = 1 will return the first mimetype from the array, 2 - will return the whole array

	function getFileMime($filename, $return = 1){

		$mimes_array = Array();

		$filename_params = pathinfo($filename	);
		$file_extansion = strtolower($filename_params['extension']);

		foreach($this->mimetypes as $key=>$value){

			if(in_array($file_extansion, $value)){
				if($return == 1){

                  return $key;
				} else {
                   $mimes_array[] = $key;
				}

			}

		}

		return $mimes_array;

	}



}



?>
